/*


 Clock applet : Small applet that shows a clock, you can set a picture on the hour and one in the middle.

	options/syntax :

	img="URL" 		: picture to be shown in the middle of the clock
	hour_img="URL"		: picture to be shown on the hours
	width=xxx		: width of the clock 
	height=xxx		: heigth of the clock
	gmt_offset=xx		: gmt offset in hours *

	* at this time this only works correctly when you live in the gmt time zone, because i have
	  no idea how to get gmt (instead of local time) without asking a server for example

	email for bugs : daniel@vpro.nl (Daniel Ockeloen) 

*/

import awt.*;
import java.lang.*;
import java.util.*;
import browser.*;
import net.www.html.*;
import Object;
import java.io.*;


class yes extends Applet implements Runnable {

	/* pictures */
	Image 		hourpic,middlepic;

	/* Threads */
	Thread		kicker = null;

	/* diff. x & y values we need */
	int 		maxx,maxx2,maxx3;
	int		maxy,maxy2,maxy3;

	/* PI & parts of PI needed for the clock */
	float		PI,PI2,PI3,PI12,PI60,PI720;

	/* Sizes of the diff. pointers */
	float		hoursizex,hoursizey;
	float		minsizex,minsizey;
	float		secsizex,secsizey;

	/* gmt offset in hours */
	int		gmt_offset = 0;


	/* 
 	 *	init : 
	 *
	 *	  read all the needed attributes and get the needed data. resize to clock size.
	 *
	 */ 
	public void init() {

		/* get attributes */
		hourpic = getImage(getAttribute("hour_img"));
		middlepic = getImage(getAttribute("img"));
		Integer at= new Integer(getAttribute("width"));
		maxx=at.intValue();
		at= new Integer(getAttribute("height"));
		maxy=at.intValue();
		if (getAttribute("gmt_offset")!=null) {
			at= new Integer(getAttribute("gmt_offset"));
			gmt_offset=at.intValue();
		}

		/* calc some values ahead */
		maxx2=maxx/2;maxy2=maxy/2;
		maxx3=maxx2+(hourpic.width/2);
		maxy3=maxy2+(hourpic.height/2);
		hoursizex=maxx2*0.7;hoursizey=maxy2*0.7;
		minsizex=maxx2*0.9;minsizey=maxy2*0.9;
		secsizex=maxx2*0.9;secsizey=maxy2*0.9;
		resize(maxx+hourpic.width,maxy+hourpic.height);
		PI=Float.PI;
		PI2=PI/2;
		PI3=PI/3;
		PI12=PI/6;
		PI60=PI/30;
		PI720=PI/360;
	}



	/* 
         *	paint : 
	 *
	 *	  paint called every second, draws the clock.
	 *
	 */ 
	public void paint(Graphics g) 
	{int	i,j;

		/* Get the current time (should be gmt time) */
		Date now = new Date();

		/* Draw the hour grafix */
		for (i=1;i<13;i++) {
			g.drawImage(hourpic,maxx2+(int)(maxx2*Math.sin(i*PI12)),maxy2+(int)(maxy2*Math.cos(i*PI12)));

		}

		
		/* draw the second pointer */
		i=90-now.getSeconds();
		g.drawLine(maxx3,maxy3,maxx3+(int)(secsizex*Math.sin(i*PI60)),maxy3+(int)(secsizey*Math.cos(i*PI60)));

		/* draw the minutes pointer */
		i=90-now.getMinutes();
		for (j=0;j<7;j++) {
			g.drawLine(maxx3+(int)((j-3)*Math.sin((i*PI60)+PI2)),maxy3+(int)((j-3)*Math.cos((i*PI60)+PI2)),maxx3+(int)(minsizex*Math.sin(i*PI60)),maxy3+(int)(minsizey*Math.cos(i*PI60)));
		}

		/* draw the hours pointer */
		i=720+360-(((now.getHours()+gmt_offset)*60)+now.getMinutes());
		for (j=0;j<7;j++) {
			g.drawLine(maxx3+(int)((j-3)*Math.sin((i*PI720)+PI2)),maxy3+(int)((j-3)*Math.cos((i*PI720)+PI2)),maxx3+(int)(hoursizex*Math.sin(i*PI720)),maxy3+(int)(hoursizey*Math.cos(i*PI720)));
		}
		g.drawImage(middlepic,maxx3-(middlepic.width/2),maxy3-(middlepic.height/2));
	}



	public void run() {

		/* main program loop, calls paint every second */
		while (kicker!=null) {
			Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
			repaint();
			Thread.sleep(1000);
		}
	}

	public void start() {
		/* Start up the main thread */
		if (kicker == null) {
			kicker = new Thread(this);
			kicker.start();
		}
	}
	
	public void stop() {
		/* Stop thread */
		kicker = null;
	}
	
	public void destroy() {
		/* Stop thread */
		kicker = null;
	}

}
