/*-------------------------------------------------------------*/
/*  File: xpoints.c
 *
 *  Draw an interesting pattern using a seemingly random
 *  process (illustrates use of XDrawPoint and XDrawPoints)
 *
 */
 /*-------------------------------------------------------------*/

#define COSDEG(x) cos((float)(x)*0.174)
#define SINDEG(x) sin((float)(x)*0.174)
#define DIST 100
#define NUMPT 8

#include <stdio.h>           /* For definition of NULL          */
#include <stdlib.h>          /* For srand, and rand             */
#include <math.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "xwins.h"
#include "app_glob.c"

#ifndef RAND_MAX
/* Assume 2**31 -1 */
#define RAND_MAX 0x7fffffff
#endif

#define MAXPTS     5000

/* Array of points */
XPoint pt[MAXPTS];
int    cpt;

/* Starting points used to generate the rest */
XPoint pseed[3] = { { 50, 200 }, { 150, 50 }, { 250, 200 } };
XPoint pnow = { 200, 200 };

struct pt3d { int x,y,z; } box[8],newbox[8];
char *quit_label = "Quit";
XEvent eventx;

/* Function prototypes */

void initapp(/* int, char **, int, int, unsigned, unsigned */);
int  quit_action(/* caddr_t */);
int dummytrue(void);
void transform(int rotatex,int rotatey,int rotatez);
void DoCoolStuff(int rx,int ry,int rz);

/*-------------------------------------------------------------*/
main(argc, argv)
int  argc;
char **argv;
{
    XWIN     *QuitButton, *which_xwin;
    unsigned quit_width, quit_height;
    int rx,ry,rz,g,l;    

    xwin_init();
        
    initapp(argc, argv, 20, 20, 300, 250);


	box[0].x = -10;
	box[0].y = -10;
	box[0].z = -10;

	box[1].x = 10;
	box[1].y = -10;
	box[1].z = -10;

	box[2].x = 10;
	box[2].y = 10;
	box[2].z = -10;

	box[3].x = -10;
	box[3].y = 10;
	box[3].z = -10;

	box[4].x = -10;
	box[4].y = 10;
	box[4].z = 10;

	box[5].x = 10;
	box[5].y = 10;
	box[5].z = 10;

	box[6].x = 10;
	box[6].y = -10;
	box[6].z = 10;

	box[7].x = -10;
	box[7].y = -10;
	box[7].z = 10;

	rx = ry = rz = 0;



/* Create the "Quit" button */
    quit_width = XTextWidth(theFontStruct, quit_label, 
                            strlen(quit_label)) + 4;
    quit_height = theFontStruct->max_bounds.ascent + 
                  theFontStruct->max_bounds.descent + 4;

    QuitButton = MakeXButton(1, 1, quit_width, quit_height,
                             1, theFGpix, theBGpix, theMain, 
                             quit_label, quit_action, NULL);

/* Compute the points to plot */
/*    compute_points();     
*/

l = 0;

/* Event handling loop */

    while (!AppDone)
    {

  if (XCheckIfEvent(theDisplay, &theEvent, dummytrue, NULL))
    {
/*        XNextEvent(theDisplay, &theEvent); */

/* Main window is handled here */
        if(theEvent.xany.window == theMain)
            if(theEvent.type == Expose && 
               theEvent.xexpose.count == 0) 
                    XClearWindow(theDisplay, theMain); 

/* For all other windows, retrieve the XWIN data from
 * Xlib using the context manager routine XFindContext
 */
        if(XFindContext(theDisplay, theEvent.xany.window,
           xwin_context, (caddr_t *) &which_xwin) == 0)
        {
/* Call the event handler of this XWIN structure */
            if(*(which_xwin->event_handler) != NULL)
              (*(which_xwin->event_handler))(which_xwin);
        }		   
	
      }

if (l++ > 1000)
  { l =0;
     DoCoolStuff(rx,ry,rz);
     rx = (rx+1)%360;
     ry = (ry+(rx%2))%360;
     rz = (rz+(ry%2))%360;
  }

    } 

/* Close connection to display and exit */

    XCloseDisplay(theDisplay);
    exit(0);
}




int dummytrue()
{ return 1; }


/*-------------------------------------------------------------*/
/*  q u i t _ a c t i o n
 *
 *  This routine is called when a ButtonPress event occurs in
 *  the quit window.
 */
int quit_action(data)
caddr_t data;
{
/* Set the done flag */
    AppDone = 1;
    return 1;
}


/* DOCUBE FUNCTION
 Handle all off screen operations then Blit  */

 void DoCoolStuff (int rx, int ry, int rz)
 { int g;
	struct oifjw { int x,y; } point2d[NUMPT];

XSetForeground(theDisplay,theGC,0);

	XFillRectangle(theDisplay,theMain,theGC,0,0,280,230);

	transform(rx,ry,rz);

	for (g=0;g<8;++g)
	    { point2d[g].x = DIST*newbox[g].x/(newbox[g].z+40) + 160;
	      point2d[g].y = DIST*newbox[g].y/(newbox[g].z+40) + 100;
		 }
XSetForeground(theDisplay,theGC,1);


	XDrawLine(theDisplay,theMain,theGC,point2d[0].x,point2d[0].y,point2d[1].x,point2d[1].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[1].x,point2d[1].y,point2d[2].x,point2d[2].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[2].x,point2d[2].y,point2d[3].x,point2d[3].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[3].x,point2d[3].y,point2d[4].x,point2d[4].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[4].x,point2d[4].y,point2d[5].x,point2d[5].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[5].x,point2d[5].y,point2d[6].x,point2d[6].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[6].x,point2d[6].y,point2d[7].x,point2d[7].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[7].x,point2d[7].y,point2d[0].x,point2d[0].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[0].x,point2d[0].y,point2d[3].x,point2d[3].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[4].x,point2d[4].y,point2d[7].x,point2d[7].y);
        XDrawLine(theDisplay,theMain,theGC,point2d[2].x,point2d[2].y,point2d[5].x,point2d[5].y);  
	XDrawLine(theDisplay,theMain,theGC,point2d[1].x,point2d[1].y,point2d[6].x,point2d[6].y);  

  }



void transform(int rotatex,int rotatey,int rotatez)
{ float tx,ty,tz;
  int g;


rotatex = (rotatex + 360) % 360;
rotatey = (rotatey + 360) % 360;
rotatez = (rotatez + 360) % 360;


 for (g=0;g<NUMPT;++g)
  {

	 tx = COSDEG(rotatez)*box[g].x - SINDEG(rotatez)*box[g].y;
	 ty = SINDEG(rotatez)*box[g].x + COSDEG(rotatez)*box[g].y;
    newbox[g].x = tx;
    newbox[g].y = ty;


    tx =  COSDEG(rotatey)*newbox[g].x + SINDEG(rotatey)*box[g].z;
    tz = -SINDEG(rotatey)*newbox[g].x + COSDEG(rotatey)*box[g].z;
    newbox[g].x = tx;
    newbox[g].z = tz;


    ty = COSDEG(rotatex)*newbox[g].y - SINDEG(rotatex)*newbox[g].z;
    tz = SINDEG(rotatex)*newbox[g].y + COSDEG(rotatex)*newbox[g].z;
    newbox[g].y = ty;
    newbox[g].z = tz;
   }
}


