/*  File:  xwinutil.c
 *
 *  Utility functions for Xlib programming.
 */
 
#define XWIN_UTIL

#include "xwins.h"
#include "app_glob.c"

/*-------------------------------------------------------------*/
void xwin_init()
{
/* Create a unique context to reference data associated
 * with the windows
 */
    xwin_context = XUniqueContext();

}
/*-------------------------------------------------------------*/
/*  A d d N e w E v e n t
 *
 *  Add a new event to a window's event mask.
 *
 */
void AddNewEvent(xid, event_mask)
Window xid;
long event_mask;
{
    XWindowAttributes     xwa;
    XSetWindowAttributes  xswa;

    if (XGetWindowAttributes(theDisplay, xid, &xwa) != 0)
    {
        xswa.event_mask = xwa.your_event_mask | event_mask;
                             
        XChangeWindowAttributes(theDisplay, xid,
                                CWEventMask, &xswa);
    }
}
/*-------------------------------------------------------------*/
/*  I g n o r e E v e n t
 *
 *  Stop handling an event (by altering the window's mask)
 *
 */
void IgnoreEvent(xid, event_mask)
Window xid;
long event_mask;
{
    XWindowAttributes     xwa;
    XSetWindowAttributes  xswa;

    if (XGetWindowAttributes(theDisplay, xid, &xwa) != 0)
    {
        xswa.event_mask = xwa.your_event_mask & (~event_mask);

        XChangeWindowAttributes(theDisplay, xid,
                                CWEventMask, &xswa);

    }
}
