/***** Includes ********/

#include <stdio.h>
#include <string.h>
#include <math.h>

/***** Global declarations ******/

#define MAX_N  64
#define MAX_FACTS 1000
#define TAG_SIZE  2		       /* number of chars in tag field */
#define num_words n

#ifndef TRUE
#define TRUE  1
#endif

#ifndef FALSE
#define FALSE   0
#endif

static int n;			       /* number of neurons actually used
				        * during run */
int debugging = FALSE;
int centering = FALSE;
int resizing = FALSE;

int cell[32][32];
int cell_max_i, cell_max_j;

struct a_fact {
  char pattern[MAX_N];
  char tag[TAG_SIZE];
} facts[MAX_FACTS];
static int next_fact = 0;

/*		Back Propagation globals		*/

#define prompt "BACK-PROP> "
#define MAX_NEURONS_PER_LAYER 64       /* better be same as MAX_N */
#define MAX_LAYER 4
#define MAX_LONG 2147483647	       /* 2^31-1 */
#define MAX_STRLEN 128
#define sign(x) (x<0 ? -1 : (x>0 ? 1 : 0))

typedef struct {		       /* extra connection is to hardwired
				        * "ON" unit */
  float connection[MAX_NEURONS_PER_LAYER + 1];
  float delta[MAX_NEURONS_PER_LAYER + 1];
  float output;
} a_site;
typedef a_site a_net[MAX_LAYER][MAX_NEURONS_PER_LAYER];
typedef char bool;
typedef struct {
  int length;
  float value[MAX_NEURONS_PER_LAYER];
} expanded_string;
typedef float float_vector[MAX_NEURONS_PER_LAYER + 1];

char comm[100];
bool show_prompts;
int seed;
int nl[MAX_LAYER], nlayer;
char parargv[20][100];
/*
char *parargv[] = {"recog","r" ,"-1", "/home/u112/phy/furm/public_html/backprop/classes/Net", "/home/u112/phy/furm/public_html/backprop/classes/data", "/home/u112/phy/furm/public_html/backprop/classes/output" };
*/
float learning_rate, momentum_rate;
a_net net;

/************** Top Level driver loop ********************/

main()
{
  char line[MAX_STRLEN];	       /* character input line */
  int new;
  int which_fact;
  struct a_fact recall_fact;
  FILE *fp;
  char name[50], which_tag[TAG_SIZE];
  int i, j, k;
  int check_every, correct_count, sweep, sweep_max;
  bool correct, word_correct;
  float epsilon;
int no_of_time = 0;
  int try, try_max, wc_count;


  n = MAX_N;
  cell_max_i = sqrt((float) n);	       /* initialize graphical things */
  cell_max_j = cell_max_i;
  my_init_things();


   fp = popen("sed -e \"\"  /hpdc4/java/public_html/backprop/classes/commandFile","r");
   if(fp ==NULL)
       { 
        perror("file not found");
        exit(1);
       }

 i =0;
  while(!feof(fp))
     {
      fscanf(fp,"%s ",&parargv[i++]);
      printf("inside .. [%s]\n",parargv[i-1]);
      }
    fclose(fp);


/*
 printf("\n[%s]\n[%s]\n[%s]\n[%s]\n[%s]\n",parargv[1], parargv[2],parargv[3],parargv[4],parargv[5]);
*/
  do {
     no_of_time++;
    if (sscanf(parargv[1],"%s",line) == 0)
      break;
    switch (line[0]) {
      case '\0':
	printf("\n");
      case '\n':
	continue;		       /* with do, not switch */
      case 'x':
	break;			       /* exit */
      case 'c':
	printf("Clearing storage...");
	next_fact = 0;
	initialize_network();
	printf("done!\n");
	continue;
      case 'A':		       /* store memory in archive */
	printf("Archiving memory...Enter name of file for archive\n");
	scanf("%s", name);
	fp = fopen(name, "w");
	printf("Archiving...");
	fwrite(&next_fact, sizeof (next_fact), 1, fp);
	fwrite(&facts[0], sizeof (struct a_fact), next_fact, fp);
	fclose(fp);
	printf("Done! archived %d facts\n", next_fact);
	continue;
      case 'B':		       /* retrieving memory from archive */
	printf("Retrieving memory from archive...Enter name of file\n");
	scanf("%s", name);
	fp = fopen(name, "r");
	printf("Retrieving...");
	fread(&next_fact, sizeof (next_fact), 1, fp);
	fread(&facts[0], sizeof (struct a_fact), next_fact, fp);
	fclose(fp);
	printf("Done! retrieved %d facts\n", next_fact);
	continue;
      case 'C':		       /* store network in archive */
	printf("Archiving network...Enter name of file for archive\n");
	scanf("%s", name);
	fp = fopen(name, "w");
	printf("Archiving...");
	fwrite(&nlayer, sizeof (nlayer), 1, fp);
	fwrite(&learning_rate, sizeof (learning_rate), 1, fp);
	fwrite(&momentum_rate, sizeof (momentum_rate), 1, fp);
	fwrite(&nlayer, sizeof (nlayer), 1, fp);
	fwrite(&nl[0], sizeof (nl), 1, fp);
	fwrite(net, sizeof (a_net), 1, fp);
	fclose(fp);
	printf("Network archived in %s!\n", name);
	continue;
      case 'D':		       /* retrieving network from archive */
           retrieve_network(parargv[2]);
	continue;
      case 'l':
	printf("Enter fact to look at:\n");
	scanf("%d", &which_fact);
	if (which_fact >= 0 && which_fact < next_fact) {
	  printf("Displaying fact %d with tag \"%s\"...",
		 which_fact, facts[which_fact].tag);
	  conv_fact_to_cells(&facts[which_fact]);
	  draw_cells();
	  printf("done!\n");
	}
	else
	  printf("No fact for number %d.\n", which_fact);
	continue;
      case 'L':
	sscanf(line, "L %s", which_tag);
	printf("Looking at tags...\n");
	for (i = 0; i < next_fact; i++) {
	  if (strcmp(facts[i].tag, which_tag) == 0) {
	    printf("Fact %d has that tag:\n", i);
	    conv_fact_to_cells(&facts[i]);
	    draw_cells();
	    printf("Hit Return to continue!");
	    getchar();
	  }
	}
	printf("That's all the facts that match \"%s\"!\n", which_tag);
	continue;
      case 'f':
	printf("Currently have %d facts stored in memory\n", next_fact);
	continue;
      case 's':		       /* store string */
	new = sscanf(line, "s %s", facts[next_fact].tag);
	printf("Getting picture to associate with \"%s\" ...\n", facts[next_fact].tag);
	get_cells();
	printf("Storing...\n");
	conv_cells_to_fact(&facts[next_fact]);
	next_fact++;
	printf("done!\n");
	continue;
      case 'r':		       /* recall from key */
           retrieve_network(parargv[3]);
	i = sscanf(parargv[2], "%d", &which_fact);
	if ((i < 1) || (which_fact < 0) || (which_fact >= next_fact)) {
	  get_cells(parargv[4]);
	  conv_cells_to_fact(&recall_fact);
	}
	else {
	  recall_fact = facts[which_fact];
	}

	run_forward(&recall_fact);
	get_fact_from_net(&recall_fact);
	conv_fact_to_cells(&recall_fact);
        fp = fopen(parargv[5],"w");
	fprintf(fp,"%c\n", recall_fact.tag[0]);
        fclose(fp);
        sprintf(comm,"chmod 777 %s",parargv[5]);
       system(comm);
	continue;
      case 'h':
	j = sscanf(line + 1, "%d", &i);
	if (j > 0)
	  show_hidden_layer(i);
	else
	  printf("Specify hidden layer you want to look at!\n");
	continue;
      case 'd':
	if (debugging) {
	  printf("Debugging turned off\n");
	  debugging = FALSE;
	}
	else {
	  printf("Debugging turned on\n");
	  debugging = TRUE;
	}
	continue;
      case 'z':
	if (resizing) {
	  printf("resizing turned off\n");
	  resizing = FALSE;
	}
	else {
	  printf("resizing turned on\n");
	  resizing = TRUE;
	}
	continue;
      case 'Z':
	if (resizing) {
	  for (i = 0; i < next_fact; i++) {
	    conv_fact_to_cells(&facts[i]);
	    resize_image();
	    conv_cells_to_fact(&facts[i]);
	  }
	}
	else {
	  printf("Resizing is not turned on!\n");
	}
	continue;
      case 'n':
	sscanf(line + 1, "%d", &new);
	if (new <= 0 || new > MAX_N) {
	  printf("ERROR: cannot change value of n from %d to %d\n", n, new);
	}
	else {
	  printf("Changing value of n from %d to %d\n", n, new);
	  n = new;
	}
	cell_max_i = sqrt((float) n);
	cell_max_j = cell_max_i;
	my_init_cell_things();
	continue;
      case 'm':		       /* memorize facts */
	sscanf(line + 1, "%d", &check_every);
	if (check_every < 1)
	  check_every = 1000;
	printf("Sweeping through presentations until correct...\n");
	correct = FALSE;
	i = 0;
	while (!correct) {
	  correct = TRUE;
	  correct_count = nl[nlayer - 1] * next_fact;
	  for (j = 0; j < next_fact; j++) {
	    run_forward(&facts[j]);
	    for (k = 0; k < nl[nlayer - 1]; k++)
	      if ((facts[j].tag[0] - 'A') == k ? (net[nlayer - 1][k].output < 0.9) : (net[nlayer - 1][k].output > 0.1)) {
		correct = FALSE;
		correct_count--;
	      }
	    back_propagate(&facts[j]);
	  }
	  i++;
	  if (i % check_every == 0)
	    printf("%4.1f%% correct on sweep %d...\n",
		   100.0 * ((float) correct_count / ((float) nl[nlayer - 1] * next_fact)), i);
	}
	printf("Memorized in %d sweeps!\n", i);
	continue;
      case 'w':		       /* sweep through pres<entations */
	sscanf(line + 1, "%d %d %f", &sweep_max, &check_every, &epsilon);
	if (sweep_max < 1)
	  sweep_max = 1;
	if (check_every < 1)
	  check_every = 100;
	if (epsilon == 0)
	  epsilon = 0.1;
	try_max = 1;
	for (i = 0; i < sweep_max;) {
	  correct_count = nl[nlayer - 1] * next_fact;
	  wc_count = 0;
	  for (j = 0; j < next_fact; j++) {
	    if (try_max < 1)
	      try_max = 1;
	    word_correct = FALSE;
	    for (try = 0; (try < try_max && (!word_correct)); try++) {
	      run_forward(&facts[j]);
	      word_correct = TRUE;
	      for (k = 0; k < nl[nlayer - 1]; k++)
		if ((facts[j].tag[0] - 'A') == k ? (fabs(1.0 - net[nlayer - 1][k].output) > epsilon) : (net[nlayer - 1][k].output > epsilon)) {
		  word_correct = FALSE;
		}
	      back_propagate(&facts[j]);
	    }
	    run_forward(&facts[j]);
	    word_correct = TRUE;
	    for (k = 0; k < nl[nlayer - 1]; k++)
	      if ((facts[j].tag[0] - 'A') == k ? (fabs(1.0 - net[nlayer - 1][k].output) > epsilon) : (net[nlayer - 1][k].output > epsilon)) {
		correct = FALSE;
		correct_count--;
		word_correct = FALSE;
	      }
	    if (word_correct)
	      wc_count++;
	  }
	  i++;
	  j = nl[nlayer - 1] * next_fact - correct_count;
	  if (j < next_fact)
	    try_max = 2;
	  if (j < next_fact / 4)
	    try_max = 4;

	  if (i % check_every == 0)
	    printf("%5.2f%% of outputs, %d/%d presentations, correct on sweep %d...\n",
		   100.0 * ((float) correct_count / ((float) nl[nlayer - 1] * next_fact)), wc_count, next_fact, i);
	}
	printf("Finished with %d sweeps at epsilon = %f!\n", sweep_max, epsilon);
	continue;
      case 'p':		       /* print network connections */
	printf("Network connections:\n");
	for (i = nlayer - 1; i > 0; i--) {
	  for (j = 0; j < nl[i]; j++) {
	    for (k = 0; k <= nl[i - 1]; k++) {
	      printf("%4.2f ", net[i][j].connection[k]);
	    }
	    printf("** ");
	  }
	  printf("\n");
	}
	continue;
      case 'g':		       /* get parameters */
	get_parameters();
	continue;
      default:
	help();
	continue;
    }
    break;
  } while (no_of_time<1);

  my_terminate_things();
/*  printf("\nIt's been real!\n"); */
 exit(0);
}

/****** Assorted subroutines *********************/

help()
{				       /* print out commands available */
  printf("Commands are:\n");
  printf("  s <tag>  Save fact with given <tag>\n");
  printf("  r <k>    Show recall of fact k\n");
  printf("  h <k>    Show hidden layer k outputs and connections\n");
  printf("  m <k>    Memorize facts, showing status every k sweeps\n");
  printf("  w <k>    Sweep through facts k times\n");
  printf("  p        Print network connections\n");
  printf("  g        Get net parameters\n");
  printf("  d        Toggle debugging\n");
  printf("  n <k>    Set value of n to k\n");
  printf("  A        Archive facts\n");
  printf("  B        Retrieve facts\n");
  printf("  C        Archive network\n");
  printf("  D        Retrieve network\n");
  printf("  e        Erase fact from memory\n");
  printf("  c        Clear all facts from memory\n");
  printf("  f        Report on number of facts in memory\n");
  printf("  l        look at a fact in memory\n");
  printf("  L <tag>  look at all facts with given tag\n");
  printf("  z        toggle resizing\n");
  printf("  x        Exit from simulation\n");
  printf("Character cell size is %d by %d.\n", cell_max_i, cell_max_j);
  printf("\n");
}


conv_cells_to_fact(factp)
struct a_fact *factp;
{
  int i, j;
  int bit_loc, word_loc, bit_in_word_loc;

  for (i = 0; i < cell_max_i; i++) {
    for (j = 0; j < cell_max_j; j++) {
      bit_loc = i * cell_max_j + j;
      if (cell[i][j] != 0)
	factp->pattern[bit_loc] = 1;
      else
	factp->pattern[bit_loc] = 0;
    }
  }
}


conv_fact_to_cells(factp)
struct a_fact *factp;
{
  int i, j;
  int bit_loc, word_loc, bit_in_word_loc;

  for (i = 0; i < cell_max_i; i++) {
    for (j = 0; j < cell_max_j; j++) {
      bit_loc = i * cell_max_j + j;
      if (factp->pattern[bit_loc])
	cell[i][j] = 1;
      else
	cell[i][j] = 0;
    }
  }
}


erase_fact(which_fact)		       /* erase a particular fact from
				        * memory */
int which_fact;
{
  int i, fact_index;

  for (fact_index = which_fact; fact_index < next_fact - 1; fact_index++) {
    for (i = 0; i < num_words; i++) {
      facts[fact_index].pattern[i] = facts[fact_index + 1].pattern[i];
    }
    for (i = 0; i < TAG_SIZE; ++i)
      facts[fact_index].tag[i] = facts[fact_index + 1].tag[i];
  }
  --next_fact;
}


get_parameters()
/*	Get all parameters for network.		*/

{
  int i;
  char temp, c;
  char line[MAX_STRLEN];
  char param_filename[MAX_STRLEN];
  FILE *pfd;

  printf("Do you want enter parameters manually (y/n)?\n");
  gets(line);
  sscanf(line, "%c", &temp);
  if ((temp == 'N') || (temp == 'n'))
    show_prompts = FALSE;
  else
    show_prompts = TRUE;
  if (!show_prompts) {
    printf("Parameter filename?\n");
    gets(line);
    sscanf(line, "%s", param_filename);
    pfd = fopen(param_filename, "r");
    if (pfd == NULL) {
      printf("Error opening %s!\n", param_filename);
      exit(1);
    }
    printf("Reading parameters from %s...\n", param_filename);
  }
  else
    pfd = stdin;
  if (show_prompts)
    printf("Random number seed?\n");
  fgets(line, MAX_STRLEN, pfd);
  sscanf(line, "%d", &seed);
  srand(seed);
  if (show_prompts)
    printf("Number of layers?\n");
  fgets(line, MAX_STRLEN, pfd);
  sscanf(line, "%d", &nlayer);
  if (nlayer > MAX_LAYER) {
    printf("ERROR: Too many layers requested, %d maximum\n", MAX_LAYER);
    exit(1);
  }
  for (i = 0; i < nlayer; i++) {
    if (show_prompts)
      printf("Number of neurons in layer %d?\n", i);
    fgets(line, MAX_STRLEN, pfd);
    sscanf(line, "%d", &nl[i]);
    if (nl[i] > MAX_NEURONS_PER_LAYER) {
      printf("ERROR: Too many neurons/layer requested, %d maximum\n", MAX_NEURONS_PER_LAYER);
      exit(1);
    }
  }
  if (show_prompts)
    printf("Learning rate?\n");
  fgets(line, MAX_STRLEN, pfd);
  sscanf(line, "%f", &learning_rate);
  if (show_prompts)
    printf("Momentum rate?\n");
  fgets(line, MAX_STRLEN, pfd);
  sscanf(line, "%f", &momentum_rate);

  if (pfd != stdin)
    fclose(pfd);

  initialize_network();
}				       /* get_parameters */


float random_uniform()
{
  return ((float) rand() / MAX_LONG);
}


initialize_network()
{
  int i, j, k;

  for (i = 1; i < nlayer; i++) {
    for (j = 0; j < nl[i]; j++) {
      /* k=nl[i-1] is for connection to hardwired "ON" unit */
      for (k = 0; k <= nl[i - 1]; k++) {
	net[i][j].connection[k] = -0.2 + (0.4 * random_uniform());
      }
      net[i][j].output = 0;
    }
  }
}				       /* initialize_network */


run_forward(factp)
struct a_fact *factp;
{
  register int i, j, k;
  register float temp;
  register a_site *net_i_j;

#define OK1 ((j%cell_max_j)!=0)
#define OK2 ((j%cell_max_j)!=cell_max_j-1)
#define OK3 (j>=cell_max_j)
#define OK4 (j<nl[0]-cell_max_j)

  /* set outputs of first layer to be 9 pt. gaussian of pattern */
  for (j = 0; j < nl[0]; j++) {
    net_i_j = &net[0][j];
    net_i_j->output = 0.4 * (float) factp->pattern[j];
    if (OK1)
      net_i_j->output += 0.1 * (float) factp->pattern[j - 1];
    if (OK2)
      net_i_j->output += 0.1 * (float) factp->pattern[j + 1];
    if (OK3)
      net_i_j->output += 0.1 * (float) factp->pattern[j - cell_max_j];
    if (OK4)
      net_i_j->output += 0.1 * (float) factp->pattern[j + cell_max_j];
    if (OK1 && OK3)
      net_i_j->output += 0.05 * (float) factp->pattern[j - cell_max_j - 1];
    if (OK2 && OK3)
      net_i_j->output += 0.05 * (float) factp->pattern[j - cell_max_j + 1];
    if (OK1 && OK4)
      net_i_j->output += 0.05 * (float) factp->pattern[j + cell_max_j - 1];
    if (OK2 && OK4)
      net_i_j->output += 0.05 * (float) factp->pattern[j + cell_max_j + 1];
  }

  for (i = 1; i < nlayer; i++) {
    for (j = 0; j < nl[i]; j++) {
      temp = 0;
      net_i_j = &net[i][j];
      for (k = 0; k < nl[i - 1]; k++) {
	temp += net_i_j->connection[k] * net[i - 1][k].output;
      }
      temp += net_i_j->connection[nl[i - 1]];	/* hardwired "ON"
						 * connection */
      net_i_j->output = 1.0 / (1.0 + exp(-temp));
    }
  }
}				       /* run_forward */

get_fact_from_net(factp)
struct a_fact *factp;
{
  int j, max_j;
  float max, max2;
  FILE *fp;

  max = -1;			       /* ouputs should be from 0 to 1 */
  max2 = 0;
  max_j = 0;
  fp = fopen("/hpdc4/java/public_html/backprop/classes/netResult","w");
  for (j = 0; j < nl[nlayer - 1]; j++)
     {
      fprintf(fp,"%f\n",(net[nlayer - 1][j].output)*100);
    if (net[nlayer - 1][j].output > max) {
      max2 = max;
      max = net[nlayer - 1][j].output;
      max_j = j;
    }
    else if (net[nlayer - 1][j].output > max2)
      max2 = net[nlayer - 1][j].output;
   }
  factp->tag[0] = 'A' + max_j;
  close(fp);
/*
  printf("Confidence of answer: %4.2f, %4.2f above next answer.\n", max, (max - max2));
*/
}				       /* get_fact_from_net */

show_hidden_layer(l)
int l;
{
  int i, j, ret;
  static float_vector show_vec;

  while (1) {
    for (i = 0; i < nl[l]; i++)
      show_vec[i] = net[l][i].output;
    printf("Showing hidden layer outputs.\n");
    ret = show_float_vector(show_vec, nl[l], TRUE, 1.0);
    if (ret < 0)
      return;
    printf("Picked neuron %d, showing connections.\n", ret);
    for (i = 0; i < nl[l - 1] + 1; i++)
      show_vec[i] = net[l][ret].connection[i];
    show_float_vector(show_vec, nl[l - 1] + 1, FALSE, 0.0);
    ret = 0;
  }
}


back_propagate(factp)
struct a_fact *factp;
{
  register int i, j, k;
  register float temp, temp2;
  register a_site *net_i_j;

  /* set error of last layer */
  for (j = 0; j < nl[nlayer - 1]; j++) {
    temp = net[nlayer - 1][j].output;
    temp2 = ((factp->tag[0] - 'A') == j ? 1.0 : 0.0);
    net[nlayer - 1][j].output = (temp2 - temp) * temp * (1 - temp);
  }

  for (i = nlayer - 1; i > 0; i--) {
    /* compute the change in connectivity strength */
    for (j = 0; j < nl[i]; j++) {
      net_i_j = &net[i][j];
      for (k = 0; k < nl[i - 1]; k++) {
	net_i_j->delta[k] = learning_rate * net_i_j->output * net[i - 1][k].output + momentum_rate * net_i_j->delta[k];
      }
      net_i_j->delta[nl[i - 1]] = learning_rate * net_i_j->output + momentum_rate * net_i_j->delta[nl[i - 1]];
    }

    /* set error of previous layer */
    for (j = 0; j < nl[i - 1]; j++) {
      temp = 0;
      for (k = 0; k < nl[i]; k++) {
	temp += net[i][k].output * net[i][k].connection[j];
      }
      temp2 = net[i - 1][j].output;
      net[i - 1][j].output = temp2 * (1.0 - temp2) * temp;
    }

    /* and update connections */
    for (j = 0; j < nl[i]; j++) {
      net_i_j = &net[i][j];
      for (k = 0; k <= nl[i - 1]; k++) {
	net_i_j->connection[k] += net_i_j->delta[k];
      }
    }
  }
}				       /* back_propagate */

retrieve_network(char name[])
{
 FILE *fp;
        if((fp = fopen(name, "r"))==NULL)
             {
              printf("file not found [%s]\n",name);;
              exit(1);
              }
        printf("Retrieving...");
        fread(&nlayer, sizeof (nlayer), 1, fp);
        fread(&learning_rate, sizeof (learning_rate), 1, fp);
        fread(&momentum_rate, sizeof (momentum_rate), 1, fp);
        fread(&nlayer, sizeof (nlayer), 1, fp);
        fread(&nl[0], sizeof (nl), 1, fp);
        fread(net, sizeof (a_net), 1, fp);
        fclose(fp);
}

get_cells(char fname[])
{
FILE *fp;
int i=0,j=0;
char filename[100];

sprintf(filename,"sed -e \"\" %s",fname);
if((fp = popen(filename,"r"))==NULL)
   {
   fprintf(stderr,"File not found\n");;
   exit(1);
   }

for(i=0;i<32;i++)
 {   
  for(j=0;j<32;j++)
  {
      fscanf(fp,"%d ",&cell[i][j]);
 }
  }
fclose(fp);
}

my_terminate_things(){
 }
my_init_things(){
initialize_network();
}
show_float_vector()
{
}
draw_cells()
{
}

my_init_cell_things()
{
}

resize_image(){
}
