/*
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 */

import awt.*;
import browser.Applet;

/**
 * An example of how to avoid excessive flashing when
 * repainting applets.
 *
 * @author Arthur van Hoff
 */
class Flash extends Applet {
    Image img;
    int ix, iy;
    int ux1, uy1, ux2, uy2;

    public void init() {
        img = getImage("images/editor.gif");
    }
    
    public void paint(Graphics g) {
        // Paint the vertical lines
        for (int x = 0 ; x < width ; x += 20) {
            g.setForeground(getColor((x*256)/width, 100, 200));
            g.fillRect(x, 0, 10, height);
            g.setForeground(getColor((x*width)/256, 200, 100));
            g.fillRect(x+10, 0, 10, height);
        }

        // Draw a black rectangle around it
        g.setForeground(Color.black);
        g.drawRect(0, 0, width-1, height-1);

        // Draw the image
        g.drawImage(img, ix, iy);
       // reset the update area
        ux1 = width;
        uy1 = height;
        ux2 = uy2 = 0;
    }

    public void update(Graphics g) {
        // Clip to the affected area
        g.clipRect(ux1, uy1, ux2 - ux1, uy2 - uy1);

        // Paint the applet
        paint(g);
    }

    int dx, dy;

    public void mouseDown(int x, int y) {
        dx = x - ix;
        dy = y - iy;
    }
    public void mouseDrag(int x, int y) {
        // Compute the new x,y position of the image
        x = Math.max(0, Math.min(x - dx, width - img.width));
        y = Math.max(0, Math.min(y - dy, height - img.height));

        // Compute the affected area
        ux1 = Math.min(ux1, Math.min(x, ix));
        uy1 = Math.min(uy1, Math.min(y, iy));
        ux2 = Math.max(ux2, Math.max(x, ix) + img.width);
        uy2 = Math.max(uy2, Math.max(y, iy) + img.height);

        // Set the new image position
        ix = x;
        iy = y;

        // Repaint the applet
        repaint();
 }
}