import awt.Color;
import awt.Font;
import awt.Graphics;
  
class Word	{
	Paragraph para;
	String value;
	Font font;
	Color fgc, bgc;
	int x,y,w,h,xw,yh;
	int mode;

public Word(String _value, Paragraph _para)	{
	value = _value;
	para = _para;
	font = para.font;
	fgc = para.fgc;
	bgc = para.bgc;
	w = font.stringWidth(value);
	h = font.height;
	x = 0; y = 0;
	xw = x+xw; yh = y+h;
							}

	public void move(int _x, int _y)	{
		x = _x;
		y = _y;
		xw = x+w; yh = y+h;
						}

	public void setForeground(Color _fgc, int mode)	{
		fgc = _fgc;
							}

	public void setBackground(Color _bgc, int mode)	{
		bgc = _bgc;
							}
  
	public void setFont(Font _font, int mode)	{	
		font = _font;
		h = font.height;
		w = font.stringWidth(value);
							}

	public void paint(Graphics g)	{
		g.drawString(value,x,yh);
					}

	public void paint(Graphics g, Font _font)	{
		font = _font;
		g.setFont(font);
		g.drawString(value,x,yh);
		g.setFont(para.font);
							}

	public void paint(Graphics g, Color _fgc)	{
		fgc = _fgc;
		g.setForeground(fgc);
		g.drawString(value,x,yh);
		g.setForeground(para.fgc);
							}
		}

class Paragraph	{
	byte bvec[];
	Word wvec[];
	int bcnt, wcnt;
	Font font;
	Color fgc, bgc;
	int x0, y0, w0, h0;
	int bw;
	int fh;
	byte sbuf[];

public Paragraph(byte _bvec[], Font _font, Color _fgc, Color _bgc, 
		int _x0, int _y0, int _w0, int _h0)
							{
	bvec = _bvec;
	bcnt = bvec.length;
	font = _font;
	fgc = _fgc; bgc = _bgc;
	x0 = _x0;
	y0 = _y0;
	w0 = _w0;
	h0 = _h0;
	bw = font.stringWidth(" ");
	fh = font.height;
	wvec = new Word[1000];
	sbuf = new byte[128];

	init();
							}

	public void init()	{
		mkwords();
		layout();
				}
	public void mkwords()	{
		int bcnt = bvec.length;
		byte b;
		int whitecnt = 0;
		byte space = (byte)' ', tab = (byte)'\t', newline = (byte)'\n';
		int soff = 0, boff = 0, woff = 0;
		for(boff = 0; boff<bcnt; boff++)	{
			b = bvec[boff];
			if((b == space)||(b == tab)||(b == newline))	{
				whitecnt++; continue;
									}
			if(whitecnt > 0)	{
				String s = new String(sbuf,0,0,soff);
				Word w = new Word(s,this);
				wvec[woff++] = w;
				whitecnt = 0;
				soff = 0;
						}
			else		{
				sbuf[soff++] = b;
					}
							}
		wcnt = woff;
				}

	public void layout()	{
		int i, x = 0, y = 0, x1 = x0+w0, y1 = y0+h0;

		for(i=0; i<wcnt; i++)	{
			Word w = wvec[i];
			String s = w.value;
			int ww = w.w, wh = w.h;
			if((x + bw + ww) >= x1)	{
				x = 0; y += wh;
						}
			w.x = x; w.y = y;
			w.xw = x+ww; w.yh = y+wh;
			x += (bw+ww);
					}
				}

	public void paint(Graphics g)		{
		for(int i=0; i<wcnt; i++)		{
			wvec[i].paint(g);
							}
						}
	public void paint(Graphics g, Font font)	{
		for(int i = 0; i<wcnt; i++)	{
			wvec[i].paint(g,font);
						}
							}
	public void paint(Graphics g, Color fgc)	{
		g.setFont(font);
		g.setForeground(fgc);
		for(int i=0; i<wcnt; i++)	{
			wvec[i].paint(g,fgc);
						}
							}
	
		}
